package ganymedes01.etfuturum.core.utils;

import java.util.ArrayList;
import java.util.List;

import ganymedes01.etfuturum.lib.Reference;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.IBlockAccess;
import net.minecraftforge.oredict.OreDictionary;

public class Utils {

    public static String getUnlocalisedName(String name) {
        return Reference.MOD_ID + "." + name;
    }

    public static String getBlockTexture(String name) {
        return Reference.ITEM_BLOCK_TEXTURE_PATH + name;
    }

    public static String getItemTexture(String name) {
        return Reference.ITEM_BLOCK_TEXTURE_PATH + name;
    }

    public static ResourceLocation getResource(String path) {
        return new ResourceLocation(path);
    }

    public static String getConainerName(String name) {
        return "container." + Reference.MOD_ID + "." + name;
    }

    @SuppressWarnings("unchecked")
    public static <T> T getTileEntity(IBlockAccess world, int x, int y, int z, Class<T> cls) {
        TileEntity tile = world.getTileEntity(x, y, z);
        if (!cls.isInstance(tile))
            return null;
        return (T) tile;
    }

    public static List<String> getOreNames(ItemStack stack) {
        List<String> list = new ArrayList<String>();
        for (int id : OreDictionary.getOreIDs(stack))
            list.add(OreDictionary.getOreName(id));

        return list;
    }
}